#include <stdio.h>
#include "graph.h"
#include "fatal.h"

struct GraphRecord
{
      int adj[max][max];
      int visited[max];
      int nodes;
};

Graph CreateGraph(int NodesCount)
{
      Graph G;
      
      G = malloc(sizeof(struct GraphRecord));
      if(G == NULL) FatalError( "Out of space!!!" );
      
      G->nodes = NodesCount;
      
      return G;
}


void DisposeGraph(Graph G)
{
     free(G);
}


/* a function to build adjacency matrix of a graph */
void buildadjm(Graph G)
   {
     int i,j;
     for(i=0;i<G->nodes;i++)
         for(j=0;j<G->nodes;j++)
          {
           printf("enter 1 if there is an edge from %d to %d, otherwise enter 0 \n", i,j);
           scanf("%d",&(G->adj[i][j]));
           }
      }

void printadjm(Graph G)
{
     int i,j;
     for(i=0;i<G->nodes;i++)
     {                            
         for(j=0;j<G->nodes;j++)
          printf(" %d",G->adj[i][j]);
         putchar('\n');
     }   
}

void ClearVisited(Graph G)
{
     int n;
     for(n=0; n<G->nodes; n++)
         G->visited[n] = 0;      
}

void dfs(Graph G)
{    
     int n;
     
     for(n=0; n<G->nodes; n++)
         if(G->visited[n] ==0)     
             dfsr(n,G);                 
}

/* a function to visit the nodes in a depth-first order */
void dfsr(int x, Graph G)
{
   int j;

   printf("The node visited: %d\n",x);
   for(j=0;j<G->nodes;j++)
      if(G->adj[x][j] ==1 && G->visited[j] ==0)
           dfsr(j,G);
}




